local version = "0.7b"
local context = UI.CreateContext("dbMini")
dbMini = {}
local UIMini = UI.Native.MapMini
local myTime
local avail = false
local dbMiniPos = {sc,sz,sa,sl,st,sol,sot,swl,swt}
local dbPlayerInfo = {tX,tY,tZ,
		pId = nil,
		pX = 0, pY = 0, pZ = 0,}
local TRK_INACTIVE=	0
local TRK_START=		1
local TRK_ACTIVE=	2
local TRK_FINISHED=	3

local trk_status = TRK_INACTIVE
local wp_coords = {}	
local last_dir = "North"

local function createFrames()
	dbMini = UI.CreateFrame("Frame", "dbMini", context)
	dbMiniB = UI.CreateFrame("Texture", "dbMiniB", dbMini)
	dbMiniC = UI.CreateFrame("Text", "dbMiniC", dbMini)	
	dbContextB = UI.CreateFrame("Texture", "dbContextB", dbMini)	
	dbContext = UI.CreateFrame("Text", "dbContext", dbContextB)
	dbContext1 = UI.CreateFrame("Text", "dbContext1", dbContextB)
	dbWaypoint = UI.CreateFrame("Frame", "dbWaypoint", context)
	dbWaypointD = UI.CreateFrame("Text", "dbWaypointD", dbWaypoint)
	dbWaypointB = UI.CreateFrame("Frame", "dbWaypointB", dbWaypoint)
	dbWaypointT = UI.CreateFrame("RiftTextfield", "dbWaypointT", dbWaypoint)
	dbWaypointG = UI.CreateFrame("Texture", "dbWaypointG", dbWaypointT)
	dbWaypointI = UI.CreateFrame("Texture", "dbWaypointI", dbWaypoint)
	dbWaypointA = UI.CreateFrame("Texture", "dbWaypointA", dbWaypoint)
	dbMiniO = UI.CreateFrame("RiftWindow", "dbMiniO", context)
	dbMiniOLock = UI.CreateFrame("Frame", "Lock", dbMiniO)
	dbMiniOClose = UI.CreateFrame("RiftButton", "dbMiniOClose", dbMiniO)
	dbAlphaO = UI.CreateFrame("RiftCheckbox", "dbAlphaO", dbMiniO)
	dbAlphaOText = UI.CreateFrame("Text", "dbAlphaOText", dbMiniO)	
	dbTextS = UI.CreateFrame("RiftSlider", "dbTextS", dbMiniO)
	dbTextSText = UI.CreateFrame("Text", "dbTextSText", dbMiniO)
	dbTextSLabel = UI.CreateFrame("Text", "dbTextSLabel", dbMiniO)	
	dbTextCLabel = UI.CreateFrame("Text", "dbTextCLabel", dbMiniO)	
	dbTextCBlock1 = UI.CreateFrame("Texture", "dbTextCBlock1", dbMiniO)
	dbTextCBlock2 = UI.CreateFrame("Texture", "dbTextCBlock2", dbMiniO)
	dbTextCBlock3 = UI.CreateFrame("Texture", "dbTextCBlock3", dbMiniO)
	dbTextCBlock4 = UI.CreateFrame("Texture", "dbTextCBlock4", dbMiniO)
	-- Main Frame --
	dbMini:SetVisible(false)
	if sl then
		dbMini:SetPoint("TOPLEFT", UIParent, "TOPLEFT", sl, st)
	else
		dbMini:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 400, 400)
	end
	dbMini:SetBackgroundColor(0,0,0,0)
	dbMini:SetLayer(UIMini:GetLayer()+1)
	-- alpha background--
	dbMiniB:SetAllPoints(dbMini)
	dbMiniB:SetBackgroundColor(0,0,0)
	if sa then
		dbMiniB:SetAlpha(sa)
	else
		dbMiniB:SetAlpha(1)
	end
	dbMiniB:SetLayer(dbMini:GetLayer()+1)	
	-- player Coordinates (text) --
	dbMiniC:SetPoint("TOPLEFT", dbMini, "TOPLEFT", 0, 0)
	dbMiniC:SetLayer(dbMini:GetLayer()+2)
	if sz then
		dbMiniC:SetFontSize(sz)
	else
		dbMiniC:SetFontSize(12)
	end
	dbMiniC:SetFontColor(71,71,71,1)
	dbMiniC:SetText("xxx,yyy,zzz")
	-- context background--
	dbContextB:SetPoint("TOPLEFT", dbMini, "TOPLEFT", 0,0)
	dbContextB:SetHeight(40)
	dbContextB:SetWidth(80)
	dbContextB:SetBackgroundColor(0,0,0)
	dbContextB:SetAlpha(1)
	dbContextB:SetLayer(dbMini:GetLayer()+3)
	dbContextB:SetVisible(false)	
	-- context menu (option) --
	dbContext:SetPoint("TOPLEFT", dbContextB, "TOPLEFT", 0,0)
	dbContext:SetLayer(dbContextB:GetLayer()+1)
	dbContext:SetFontSize(12)
	dbContext:SetFontColor(71,71,71,1)
	dbContext:SetText("Open Options")
	-- context menu (waypoint) --
	dbContext1:SetPoint("TOPLEFT", dbContext, "BOTTOMLEFT", 0,0)
	dbContext1:SetLayer(dbContextB:GetLayer()+1)
	dbContext1:SetFontSize(12)
	dbContext1:SetFontColor(71,71,71,1)
	dbContext1:SetText("Set Waypoint")
	 -- context waypoint cood field --
	dbWaypointT:SetAllPoints(dbWaypointD)
	dbWaypointT:SetBackgroundColor(0,0,0,1)
	dbWaypointT:SetLayer(dbWaypointD:GetLayer()+1)
	dbWaypointT:SetText("")
	dbWaypointT:SetVisible(false)
	-- Waypoint go button --
	dbWaypointG:SetPoint("TOPLEFT", dbWaypointT, "TOPRIGHT", -22,-1)
	dbWaypointG:SetLayer(dbWaypointT:GetLayer()+1)
	dbWaypointG:SetWidth(21)
	dbWaypointG:SetHeight(21)
	dbWaypointG:SetTexture("DBsMiniCoord", "img/compass-go.png")
	-- Options Frame --
	dbMiniO:SetVisible(false)
	if sol then
		dbMiniO:SetPoint("TOPLEFT", UIParent, "TOPLEFT", sol, sot)
	else
		dbMiniO:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 400, 400)
	end
	dbMiniO:SetWidth(480)
	dbMiniO:SetHeight(350)	
	dbMiniO:SetBackgroundColor(0,0,0,0)
	dbMiniO:SetLayer(UIMini:GetLayer()+1)	
	dbMiniO:SetTitle("DeaDBeaT's Mini Coords Options v" .. version)
	-- Waypoint Frame --
	dbWaypoint:SetVisible(false)
	if swl then
		dbWaypoint:SetPoint("TOPLEFT", UIParent, "TOPLEFT", swl, swt)
	else
		dbWaypoint:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 400, 400)
	end
	dbWaypoint:SetHeight(118)
	dbWaypoint:SetWidth(98)
	dbWaypoint:SetBackgroundColor(71,71,71,1)
	dbWaypoint:SetLayer(UIMini:GetLayer()+1)
	dbWaypointB:SetPoint("TOPLEFT", dbWaypoint, "TOPLEFT", 1,1)
	dbWaypointB:SetHeight(116)
	dbWaypointB:SetWidth(96)
	dbWaypointB:SetBackgroundColor(0,0,0,1)
	dbWaypointB:SetLayer(dbWaypoint:GetLayer()+1)
	-- watpoint distance text --
	dbWaypointD:SetPoint("TOPLEFT", dbWaypoint, "TOPLEFT", 1,98)
	dbWaypointD:SetWidth(96)
	dbWaypointD:SetHeight(18)
	dbWaypointD:SetBackgroundColor(0,0,0,1)
	dbWaypointD:SetLayer(dbWaypointB:GetLayer()+1)
	-- Waypoint face --
	dbWaypointI:SetPoint("TOPLEFT", dbWaypoint, "TOPLEFT", 1,1)
	dbWaypointI:SetLayer(dbWaypointB:GetLayer()+1)
	dbWaypointI:SetWidth(96)
	dbWaypointI:SetHeight(96)
	dbWaypointI:SetTexture("DBsMiniCoord", "img/compass-background.png")
	-- Waypoint arrow --
	dbWaypointA:SetPoint("TOPLEFT", dbWaypoint, "TOPLEFT", 1,1)
	dbWaypointA:SetLayer(dbWaypointI:GetLayer()+1)
	dbWaypointA:SetWidth(96)
	dbWaypointA:SetHeight(96)
	dbWaypointA:SetTexture("DBsMiniCoord", "img/compass-North.png")
	--  Movement  --
	dbMiniOLock:SetWidth(430)
	dbMiniOLock:SetHeight(50)
	dbMiniOLock:SetBackgroundColor(0,0,0,0)
	dbMiniOLock:SetPoint("TOPLEFT", dbMiniO, "TOPLEFT", 5,5)
	dbMiniOLock:SetVisible(true)	
	-- Close Btn  --
	dbMiniOClose:SetSkin("close")
	dbMiniOClose:SetPoint("TOPRIGHT", dbMiniO, "TOPRIGHT", -8, 15)	
	-- text size label --
	dbTextSLabel:SetPoint("TOPLEFT", dbMiniO, "TOPLEFT", 40, 75)
	dbTextSLabel:SetLayer(dbContextB:GetLayer()+1)
	dbTextSLabel:SetFontSize(16)
	dbTextSLabel:SetFontColor(71,71,71,1)
	dbTextSLabel:SetText("Text Size: ")
	-- text size --
	dbTextS:SetPoint("TOPLEFT", dbTextSLabel, "TOPLEFT", 0, 50)
	dbTextS:SetRange(8, 22)
	dbTextS:SetPosition(dbMiniC:GetFontSize())
	dbTextSText:SetPoint("TOPLEFT", dbTextSLabel, "TOPRIGHT", 10, 0)
	dbTextSText:SetLayer(dbMiniO:GetLayer()+1)
	dbTextSText:SetFontSize(16)
	dbTextSText:SetFontColor(1,1,1,1)
	dbTextSText:SetText(tostring(dbMiniC:GetFontSize()))
	function dbTextS.Event:SliderChange()
		dbMiniC:SetFontSize(dbTextS:GetPosition())
		dbTextSText:SetText(tostring(dbMiniC:GetFontSize()))
	end	
	-- text color label --
	dbTextCLabel:SetPoint("TOPLEFT", dbMiniO, "TOPLEFT", 40, 170)
	dbTextCLabel:SetLayer(dbContextB:GetLayer()+1)
	dbTextCLabel:SetFontSize(16)
	dbTextCLabel:SetFontColor(71,71,71,1)
	dbTextCLabel:SetText("Text Color: ")
	-- text color --
	dbTextCBlock1:SetPoint("TOPLEFT", dbTextCLabel, "TOPLEFT", 5, 35)
	dbTextCBlock1:SetLayer(dbMiniO:GetLayer()+1)
	dbTextCBlock1:SetBackgroundColor(71,71,71,1)
	function dbTextCBlock1.Event:LeftDown()
		self.MouseDown = true
		dbMiniC:SetFontColor(71,71,71,1)
	end	
	dbTextCBlock2:SetPoint("TOPLEFT", dbTextCLabel, "TOPLEFT", 50, 35)
	dbTextCBlock2:SetLayer(dbMiniO:GetLayer()+1)
	dbTextCBlock2:SetBackgroundColor(.5,.5,.5,1)
	function dbTextCBlock2.Event:LeftDown()
		self.MouseDown = true
		dbMiniC:SetFontColor(.5,.5,.5,1)
	end	
	dbTextCBlock3:SetPoint("TOPLEFT", dbTextCLabel, "TOPLEFT", 95, 35)
	dbTextCBlock3:SetLayer(dbMiniO:GetLayer()+1)
	dbTextCBlock3:SetBackgroundColor(0,0,0,1)
	function dbTextCBlock3.Event:LeftDown()
		self.MouseDown = true
		dbMiniC:SetFontColor(0,0,0,1)
	end	
	dbTextCBlock4:SetPoint("TOPLEFT", dbTextCLabel, "TOPLEFT", 140, 35)
	dbTextCBlock4:SetLayer(dbMiniO:GetLayer()+1)
	dbTextCBlock4:SetBackgroundColor(1,1,1,1)
	function dbTextCBlock4.Event:LeftDown()
		self.MouseDown = true
		dbMiniC:SetFontColor(1,1,1,1)
	end	
	-- alpha background options --
	dbAlphaO:SetPoint("TOPLEFT", dbMiniO, "TOPLEFT", 40, 275)
	dbAlphaO:SetWidth(20)
	dbAlphaO:SetHeight(20)
	dbAlphaOText:SetPoint("TOPLEFT", dbAlphaO, "TOPRIGHT", 20, 0)
	dbAlphaOText:SetLayer(dbMiniO:GetLayer()+1)
	dbAlphaOText:SetFontSize(16)
	dbAlphaOText:SetFontColor(71,71,71,1)
	if (dbMiniB:GetAlpha()== 1) then
		dbAlphaO:SetChecked(true)
		dbAlphaOText:SetText("Background ON")
	else
		dbAlphaO:SetChecked(false)
		dbAlphaOText:SetText("Background OFF")
	end
	function dbAlphaO.Event:CheckboxChange()

		if dbAlphaO:GetChecked() then
			dbAlphaOText:SetText("Background ON")
			dbMiniB:SetAlpha(1)
		else
			dbAlphaOText:SetText("Background OFF")
			dbMiniB:SetAlpha(0)
		end
	end
	-- mouse stuff --
	function dbMini.Event:LeftDown()
		self.MouseDown = true
		mouseData = Inspect.Mouse()
		self.sx = mouseData.x - dbMini:GetLeft()
		self.sy = mouseData.y - dbMini:GetTop()
	end
	function dbMini.Event:MouseMove()
		if self.MouseDown then
			local nx, ny
			mouseData = Inspect.Mouse()
			nx = math.floor(mouseData.x - self.sx)
			ny = math.floor(mouseData.y - self.sy)
			dbMini:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx, ny)
			dbMiniPos.left = nx
			dbMiniPos.top = ny
		end
	end 
	function dbMini.Event:LeftUp()
		if self.MouseDown then
			self.MouseDown = false
		end
	end
	function dbMini.Event:RightClick()
		dbContextB:SetVisible(true)
	end
	function dbWaypoint.Event:LeftDown()
		self.MouseDown = true
		mouseData = Inspect.Mouse()
		self.swx = mouseData.x - dbWaypoint:GetLeft()
		self.swy = mouseData.y - dbWaypoint:GetTop()
	end
	function dbWaypoint.Event:MouseMove()
		if self.MouseDown then
			local nwx, nwy
			mouseData = Inspect.Mouse()
			nwx = math.floor(mouseData.x - self.swx)
			nwy = math.floor(mouseData.y - self.swy)
			dbWaypoint:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nwx, nwy)
			dbMiniPos.wleft = nwx
			dbMiniPos.wtop = nwy
	end
	end 
	function dbWaypoint.Event:LeftUp()
		if self.MouseDown then
			self.MouseDown = false
		end
	end	
	function dbWaypoint.Event:RightClick()
		dbWaypoint:SetVisible(false)
		trk_status = TRK_INACTIVE
	end	
	function dbWaypointG.Event:LeftDown()
		dbWaypointT:SetVisible(false)
		dbWaypointD:SetLayer(dbWaypointT:GetLayer()+1)
		if (dbWaypointT:GetText() ~= "") then	
			getCoords(dbWaypointT:GetText())
			dbWaypointT:SetText("")
			dbWaypointT:SetKeyFocus(false)
			trk_status = TRK_ACTIVE
		else
			dbWaypointT:SetText("")
			dbWaypointT:SetKeyFocus(false)
			dbWaypoint:SetVisible(false)
			trk_status = TRK_INACTIVE
		end
	end
	function dbContext.Event:LeftDown()
		dbContextB:SetVisible(false)
		dbMiniO:SetVisible(true)
	end	
	function dbContext1.Event:LeftDown()
		dbContextB:SetVisible(false)
		dbWaypoint:SetVisible(true)
		dbWaypointT:SetVisible(true)
		dbWaypointT:SetKeyFocus(true)
		dbWaypointT:SetLayer(dbWaypointD:GetLayer()+1)
	end
	function dbContextB.Event:RightClick()
		dbContextB:SetVisible(false)
	end	
	function dbMiniOLock.Event:LeftDown()
		self.MouseDown = true
		mouseData = Inspect.Mouse()
		self.sox = mouseData.x - dbMiniO:GetLeft()
		self.soy = mouseData.y - dbMiniO:GetTop()
	end		
	function dbMiniOLock.Event:MouseMove()
		if self.MouseDown then
			local nox, noy
			mouseData = Inspect.Mouse()
			nox = math.floor(mouseData.x - self.sox)
			noy = math.floor(mouseData.y - self.soy)
			dbMiniO:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nox, noy)
			dbMiniPos.oleft = nox
			dbMiniPos.otop = noy
		end
	end 
	function dbMiniOClose.Event:LeftPress()
		dbMiniO:SetVisible(false)
	end
	function dbMiniOLock.Event:LeftUp()
		if self.MouseDown then
			self.MouseDown = false
		end
	end	
end
-- process waypoint coords --
function getCoords(cText)
	local _coords = {}
	local cnt=1
	local d_args = string.gsub(cText, "[^%d]", " ")
	for token in string.gmatch(d_args, "[%d]+") do
		_coords[cnt] = token
		cnt=cnt+1
	end
	local c1 = tonumber(_coords[1])
	local c2 = tonumber(_coords[2])
	if (c1~=nil) and (c2~=nil) then
		wp_coords.x = c1
		wp_coords.y = c2
		print(string.format("Tracking to %d, %d", c1,c2))
		trk_status = TRK_START
	else
		print("Can make no sense of: "..cText)
		print("Enter waypoints to world coords XXXX,YYYY")
		dbWaypoint:SetVisible(false)
	end
end
-- waypoint direction --
function handleDirection(dx, dy)
	local angle = math.rad(math.atan2(dy,dx)*180/math.pi)
	if angle >= 2.8		then	return {l = "East" }
	elseif angle >= 2		then	return {l = "NorthEast" }
	elseif angle >= 1.2 	then	return {l = "North" }
	elseif angle >= 0.4 	then	return {l = "NorthWest" }
	elseif angle >= -0.4	then	return {l = "West" }
	elseif angle >= -1.2	then	return {l = "SouthWest" }
	elseif angle >= -2.8	then	return {l = "South" }
	elseif angle >= -3.6	then	return {l = "SouthEast" }
	end
end
function onUpdate()
	if trk_status == TRK_ACTIVE then
		if dbPlayerInfo.pX ~= nil then
			local dx = dbPlayerInfo.pX - wp_coords.x
			local dy = dbPlayerInfo.pZ - wp_coords.y
			--print(string.format("%.2f",math.atan2(dbPlayerInfo.pX,dbPlayerInfo.pZ)))
			local cardinal = handleDirection(dx,dy).l
			if cardinal ~= last_dir then
				last_dir = cardinal
				dbWaypointA:SetTexture("DBsMiniCoord", "img/"..cardinal..".png")
			end
			local distance = math.sqrt((dx^2)+(dy^2))
			dbWaypointD:SetText(string.format("%4.0f meters", distance))
			if distance <= 5 then 
				print("You have reached your destination!")
				trk_status = TRK_FINISHED	
			elseif distance <= 7 then
				dbWaypointB:SetBackgroundColor(0,1,0,1)
			else	
				dbWaypointB:SetBackgroundColor(0,0,0,1)
			end
		end			
	elseif trk_status == TRK_FINISHED then
		dbWaypointB:SetBackgroundColor(0,0,0,1)
		dbWaypoint:SetVisible(false)
		trk_status = TRK_INACTIVE
	end
end
-- display
function UIMini.Event:Loaded() 
	dbMini:SetVisible(UIMini:GetLoaded()) 
	dbMiniC:SetVisible(UIMini:GetLoaded())
end
-- get player coordinates --
function getPlayerCoords()
	if (Inspect.Unit.Detail(dbPlayerInfo.pId).coordX ~= nil) then
		dbPlayerInfo.pX = math.floor(Inspect.Unit.Detail(dbPlayerInfo.pId).coordX)
		dbPlayerInfo.pY = math.floor(Inspect.Unit.Detail(dbPlayerInfo.pId).coordY)
		dbPlayerInfo.pZ = math.floor(Inspect.Unit.Detail(dbPlayerInfo.pId).coordZ)
		dbMiniC:SetText(dbPlayerInfo.pX .. "," .. dbPlayerInfo.pZ)
		dbMini:SetHeight(dbMiniC:GetHeight())
		dbMini:SetWidth(dbMiniC:GetWidth())
	end
end
local function myTimer()
	if avail then
		if (myTime >= 30) then
			getPlayerCoords()
			onUpdate()
			myTime = math.floor(Inspect.Time.Frame())
		else
			myTime = myTime + 1
		end
	end
end
local function onHold()
	if (Inspect.Unit.Detail(dbPlayerInfo.pId) == nil) then
		avail = false
	end
end
local function saveDBMini()
	 local mx = math.floor(dbMini:GetLeft())
	 local my = math.floor(dbMini:GetTop())
	 local ox = math.floor(dbMiniO:GetLeft())
	 local oy = math.floor(dbMiniO:GetTop())
	 local wx = math.floor(dbWaypoint:GetLeft())
	 local wy = math.floor(dbWaypoint:GetTop())
	 local ma = dbMiniB:GetAlpha()
	 local ms = dbMiniC:GetFontSize()
	 local mc = dbMiniC:GetFontColor()
	left = mx
	top = my
	oleft = ox
	otop = oy
	wleft = wx
	wtop = wy
	a = ma
	s = ms
	c = mc
end
local function loadDBMini()
	if c then sc = c end
	if s then sz = s end
	if a then sa = a end
	if left then sl = left end 
	if top then st = top end
	if oleft then sol = oleft end 
	if otop then sot = otop end
	if wleft then swl = wleft end 
	if wtop then swt = wtop end	
	--print("Loaded: " .. a,left,top)
end
-- Addon Init kinda--
local function startup()
	if (addonLoaded == DBsMiniCoord) then
		if (dbPlayerInfo.pId == nil) then 
			dbPlayerInfo.pId = Inspect.Unit.Lookup("player")
			createFrames()
		end
	end
end
-- Addon Init real (stoopid partial data) -- also fires for unit available--
local function realStartup()
	if (Inspect.Unit.Detail(dbPlayerInfo.pId) ~= nil) then
		avail = true
		myTime = math.floor(Inspect.Time.Frame())	
	end
end	
-- save/load variables
table.insert(Event.Addon.SavedVariables.Save.Begin, {saveDBMini, "DBsMiniCoord", "Save variables"})
table.insert(Event.Addon.SavedVariables.Load.End, {loadDBMini, "DBsMiniCoord", "Load variables"})
-- Register the slash commands
table.insert(Command.Slash.Register("DBsMiniCoord"), {showDBsMap, "DBsMiniCoord", "Slash command"})
print("v" .. version .. " . DeaDBeaTs MiniCoordinates Loaded")
-- initialisation
table.insert(Event.Unit.Availability.Partial, {onHold,"DBsMiniCoord","onHold"})
table.insert(Event.Unit.Availability.None, {onHold,"DBsMiniCoord","onHold"})
table.insert(Event.Unit.Availability.Full, {realStartup,"DBsMiniCoord","realStartup"})
table.insert(Event.Addon.Load.End, {startup, "DBsMiniCoord", "addonLoaded"})
table.insert(Event.System.Update.Begin, {myTimer,  "DBsMiniCoord",  "getPlayerCoords"})
--table.insert(Event.Map.Detail.Coord, {printCoords,"DBsMiniCoord","printCoords"})